
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.AbstractAction;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;
import java.io.IOException;


/**
  *
  * Beschreibung:
  *
  * @version 1.0 vom 01.02.2006
  * @author
  */

public class Gui extends JFrame {
    // Anfang Variablen
    
    private static Gui gui;
    private static Moeblierung moeblierung;
    private Zeichenflaeche zeichenflaeche;
    
    private JTable tabelle;
    private JScrollPane tabScroll;
    private AbstractTableModel dasModell;
        
    private JButton uebernehmenButton;
  
    private JPanel jButtonGroup1Panel;
    private ButtonGroup jButtonGroup1;
    private JRadioButton jButtonGroup1ButtonStuhl;
    private JRadioButton jButtonGroup1ButtonTisch;
    private JRadioButton jButtonGroup1ButtonSchrank;
    private JRadioButton jButtonGroup1ButtonBett;

    // Ende Variablen

    /**
     * Konstruktor
     */
    private Gui(String title, int breite, int hoehe) {
        // Frame-Initialisierung
        super(title);
        setJMenuBar(machMenueLeiste());
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt){ beendenAction(); }
        });
        
        jButtonGroup1Panel=machButtonGruppe();
        
        // Attribute
        setSize(breite, hoehe);
        setLocation(20, 20);
        Container contentPane = getContentPane();
        contentPane.setLayout(null);
    
        // Anfang Komponenten
        
        // Buttons
        uebernehmenButton = new JButton ("bernehmen");
        uebernehmenButton.setBounds(10, 200, 160, 20);
        contentPane.add(uebernehmenButton);
        contentPane.add(jButtonGroup1Panel);
        
        // Zeichenflaeche (JPanel)
        zeichenflaeche = new Zeichenflaeche(breite-200, hoehe-100);
        JScrollPane scroll = new JScrollPane(zeichenflaeche);
        scroll.setBounds(220, 10, breite-230, hoehe-100);
        contentPane.add(scroll);

        // Tabelle
        dasModell = new ModellKlasse();
        tabelle = new JTable(dasModell);
        tabScroll = new JScrollPane(tabelle);
        tabScroll.setBounds(10, 30, 180, 114);
        contentPane.add(tabScroll);
        
        // Ende Komponenten
    
        setResizable(false);
        setVisible(true);
        zeichenflaeche.repaint();
    
        // Anfang Ereignisprozeduren
        uebernehmenButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });
        
        // Ende Ereignisprozeduren
    }


    /**
     * Definition der Menleiste
     */
    private JMenuBar machMenueLeiste() {
        // enthaltene Objekte definieren
        JMenuBar menueLeiste = new JMenuBar();

        JMenu menueDatei = new JMenu("Datei");
        JMenuItem menueEintragOeffnen = new JMenuItem();
        JMenuItem menueEintragSpeichern = new JMenuItem("Speichern");
        JMenuItem menueEintragEnde = new JMenuItem("Ende");

        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        JMenuItem menueEintragMoebelHinzufuegen = new JMenuItem("Moebel hinzufgen");
        JMenuItem menueEintragMoebelEntfernen = new JMenuItem("Moebel entfernen");
        JMenuItem menueEintragWaehle = new JMenuItem("whle aus");
        JMenuItem menueEintragWaehleNicht = new JMenuItem("lsche Auswahl");

        // Listener definieren
        menueEintragOeffnen.setAction(new AbstractAction("ffnen") {
            public void actionPerformed(ActionEvent e) {
                holenAktion();
           }
        });

        menueEintragSpeichern.addActionListener(new AbstractAction("Speichern") {
            public void actionPerformed(ActionEvent e) {
                sichernAktion();
            }
        });

        menueEintragEnde.addActionListener(new AbstractAction("Ende") {
            public void actionPerformed(ActionEvent e) { beendenAction(); }
        });

        menueEintragMoebelHinzufuegen.addActionListener(new AbstractAction("Mbel hinzufgen") {
            public void actionPerformed(ActionEvent e) {
                uebernehmenAktion();
            }
        });

        menueEintragMoebelEntfernen.addActionListener(new AbstractAction("Mbel entfernen") {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Mbel entfernen - nicht implementiert");
            }
        });

        menueEintragWaehle.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                moeblierung.waehleAus();
                update();
            }
        });

        menueEintragWaehleNicht.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                moeblierung.loescheAuswahl();
                update();
            }
        });


        // hinzufgen
        menueDatei.add(menueEintragOeffnen);
        menueDatei.add(menueEintragSpeichern);
        menueDatei.add(menueEintragEnde);

        menueBearbeiten.add(menueEintragMoebelHinzufuegen);
        menueBearbeiten.add(menueEintragMoebelEntfernen);
        menueBearbeiten.add(menueEintragWaehle);
        menueBearbeiten.add(menueEintragWaehleNicht);

        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);

        return menueLeiste;
    }
    // Ende der Definitionsmethode fr die Menleiste
    
    // Definition der Radiobutton - Gruppe
    private JPanel machButtonGruppe(){
        jButtonGroup1Panel = new JPanel();
        jButtonGroup1 = new ButtonGroup();
        jButtonGroup1Panel.setBounds(24, 240, 140 , 137);
        jButtonGroup1Panel.setLayout(new GridLayout(4, 1));
        jButtonGroup1ButtonStuhl = machJRadioButton("Stuhl");
        jButtonGroup1.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1Panel.add(jButtonGroup1ButtonStuhl);
        jButtonGroup1ButtonTisch = machJRadioButton("Tisch");
        jButtonGroup1.add(jButtonGroup1ButtonTisch);
        jButtonGroup1Panel.add(jButtonGroup1ButtonTisch);
        jButtonGroup1ButtonSchrank = machJRadioButton("Schrank");
        jButtonGroup1.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1Panel.add(jButtonGroup1ButtonSchrank);
        jButtonGroup1ButtonBett = machJRadioButton("Bett");
        jButtonGroup1.add(jButtonGroup1ButtonBett);
        jButtonGroup1Panel.add(jButtonGroup1ButtonBett);
        jButtonGroup1ButtonStuhl.setSelected(true);
        return jButtonGroup1Panel;
    }
    
    private JRadioButton machJRadioButton(String command){
        JRadioButton jRadioButton = new JRadioButton(command);
        jRadioButton.setActionCommand(command);
        return jRadioButton;
    }
    // Ende der Definitionsmethode fr die Radiobutton - Gruppe
   
    // definition der Modellklasse
    private class ModellKlasse extends AbstractTableModel {
        private String[] spaltenBeschriftungen = { "Attribut", "Wert" };
        private Object[][] daten = new String[6][2];
        public ModellKlasse(){
            setzeDaten();
        }
        // Implementation bzw. berschreiben der Methoden
        public String getColumnName(int col) { return spaltenBeschriftungen[col]; }
        public int getRowCount() { return daten.length; }
        public int getColumnCount() { return spaltenBeschriftungen.length; }
        public boolean isCellEditable(int row, int col) { if (col==0) return false; else return true; }
        public Object getValueAt(int row, int col) { return daten[row][col]; }
        public void setValueAt(Object value, int row, int col) {
            if (col==1) {
                daten[row][col] = value;
                fireTableCellUpdated(row, col);
            }
        }
        
        private void setzeDaten(){
            daten[0][0]="x-Position"; daten[0][1]="20";
            daten[1][0]="y-Position"; daten[1][1]="20";
            daten[2][0]="Farbe     "; daten[2][1]="rot";
            daten[3][0]="Richtung  "; daten[3][1]="0";
            daten[4][0]="Breite    "; daten[4][1]="40";
            daten[5][0]="Tiefe     "; daten[5][1]="40";
        }
    }
    
    
    
    // Commands
    private void uebernehmenAktion(){
        if (moeblierung.neuesMoebel(
                jButtonGroup1.getSelection().getActionCommand(),
                (String)dasModell.getValueAt(0,1),
                (String)dasModell.getValueAt(1,1),
                (String)dasModell.getValueAt(2,1),
                (String)dasModell.getValueAt(3,1),
                (String)dasModell.getValueAt(4,1),
                (String)dasModell.getValueAt(5,1)))
        update();
        else JOptionPane.showMessageDialog(this, "Fehler bei den Daten");
    }
    
    private void sichernAktion(){
        try{
            moeblierung.sichern();
        } catch (IOException ioe){ System.out.println("! Ein-Ausgabefehler !");
        }
        update();
    }
    
    private void holenAktion(){
        try{
            moeblierung.holen();
        } catch (ClassNotFoundException cnfe){ System.out.println("! Klasse nicht gefunden !");
        } catch (IOException ioe){ System.out.println("! Ein-Ausgabefehler !");
        }
        update();
    }
    
    private void beendenAction(){ 
        int option= JOptionPane.showConfirmDialog(this, "Zustand speichern ?", "Anwendung beenden" , JOptionPane.YES_NO_CANCEL_OPTION);
        if (option==JOptionPane.YES_OPTION) sichernAktion();
        else if (option==JOptionPane.NO_OPTION) System.exit(0);
    }
    
    private void update(){
        zeichenflaeche.setList(moeblierung.gibZeichnung());
        zeichenflaeche.repaint();
        dasModell.fireTableDataChanged();
    }
        
    public static void main(String[] args) {
        moeblierung = new Moeblierung();
        gui = new Gui("Gui", 600, 600);
    }
}

